Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.type
Class AnyFunctionType

    java.lang.Object
      net.sf.saxon.type.AnyFunctionType

All Implemented Interfaces:
  Serializable, FunctionItemType, ItemType

Direct Known Subclasses:
  FunctionType, MapType

    public class AnyFunctionType

extends Object
implements FunctionItemType

An ItemType representing the type function(). Subtypes represent function items with more specific type signatures.

See Also:
  Serialized Form

Field Summary
`static AnyFunctionType` | `ANY_FUNCTION`
`static SequenceType` | `SINGLE_FUNCTION`

Constructor Summary
`AnyFunctionType()`

Method Summary
`SequenceType[]` | `getArgumentTypes()` Get the argument types of the function
`AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized
`double` | `getDefaultPriority()` Determine the default priority of this item type when used on its own as a Pattern
`static AnyFunctionType` | `getInstance()` Get the singular instance of this type (Note however that subtypes of this type may have any number of instances)
`ItemType` | `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
`int` | `getPrimitiveType()` Get the primitive type corresponding to this item type.
`SequenceType` | `getResultType()` Get the result type
`ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
`boolean` | `isAtomicType()` Determine whether this item type is an atomic type
`boolean` | `isAtomizable()` Ask whether values of this type are atomizable
`boolean` | `isMapType()` Ask whether this function item type is a map type.
`boolean` | `isPlainType()` Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
`Expression` | `makeFunctionSequenceCoercer(Expression exp, RoleLocator role, TypeCheckerEnvironment visitor)` Create an expression whose effect is to apply function coercion to coerce a function from this type to another type
`boolean` | `matches(Item item, XPathContext context)` Test whether a given item conforms to this type
`boolean` | `matchesItem(Item item, boolean allowURIPromotion, Configuration config)` Test whether a given item conforms to this type
`int` | `relationship(FunctionItemType other, TypeHierarchy th)` Determine the relationship of one function item type to another
`String` | `toString()` Produce a representation of this type name for use in error messages.
`String` | `toString(NamePool pool)` Produce a representation of this type name for use in error messages.
`void` | `visitNamedSchemaComponents(SchemaComponentVisitor visitor)` Visit all the schema components used in this ItemType definition

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### ANY_FUNCTION

    public static AnyFunctionType ANY_FUNCTION

### SINGLE_FUNCTION

    public static SequenceType SINGLE_FUNCTION

Constructor Detail

### AnyFunctionType

    public AnyFunctionType()

Method Detail

### getInstance

    public static AnyFunctionType getInstance()

  Get the singular instance of this type (Note however that subtypes of this type may have any number of instances)

### isAtomicType

    public boolean isAtomicType()

  Determine whether this item type is an atomic type

  Specified by:
    `isAtomicType` in interface `ItemType`
  Returns:
    true if this is ANY_ATOMIC_TYPE or a subtype thereof

### isPlainType

    public boolean isPlainType()

  Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)

  Specified by:
    `isPlainType` in interface `ItemType`
  Returns:
    true if this is ANY_ATOMIC_TYPE or a subtype thereof

### isMapType

    public boolean isMapType()

  Ask whether this function item type is a map type. In this case function coercion (to the map type) will never succeed.

  Specified by:
    `isMapType` in interface `FunctionItemType`
  Returns:
    true if this FunctionItemType is a map type

### getArgumentTypes

    public SequenceType[] getArgumentTypes()

  Get the argument types of the function

  Specified by:
    `getArgumentTypes` in interface `FunctionItemType`
  Returns:
    the argument types, as an array of SequenceTypes, or null if this is the generic function type function(*)

### matches

    public boolean matches(Item item,
                           XPathContext context)

  Test whether a given item conforms to this type

  Specified by:
    `matches` in interface `ItemType`
  Parameters:
    `item` - The item to be tested
    `context` - the XPath dynamic evaluation context
  Returns:
    true if the item is an instance of this type; false otherwise

### matchesItem

    public boolean matchesItem(Item item,
                               boolean allowURIPromotion,
                               Configuration config)

  Test whether a given item conforms to this type

  Specified by:
    `matchesItem` in interface `ItemType`
  Parameters:
    `item` - The item to be tested
    `allowURIPromotion` -
    `config` -
  Returns:
    true if the item is an instance of this type; false otherwise

### getSuperType

    public ItemType getSuperType(TypeHierarchy th)

  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xs:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

  Specified by:
    `getSuperType` in interface `ItemType`
  Parameters:
    `th` - the type hierarchy cache
  Returns:
    the supertype, or null if this type is item()

### getPrimitiveItemType

    public ItemType getPrimitiveItemType()

  Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that integer, xs:dayTimeDuration, and xs:yearMonthDuration are considered to be primitive types. For function items it is the singular instance FunctionItemType.getInstance().

  Specified by:
    `getPrimitiveItemType` in interface `ItemType`
  Returns:
    the corresponding primitive type

### getPrimitiveType

    public int getPrimitiveType()

  Get the primitive type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

  Specified by:
    `getPrimitiveType` in interface `ItemType`
  Returns:
    the integer fingerprint of the corresponding primitive type

### toString

    public String toString(NamePool pool)

  Produce a representation of this type name for use in error messages.

  Specified by:
    `toString` in interface `ItemType`
  Parameters:
    `pool` - the name pool
  Returns:
    a string representation of the type, in notation resembling but not necessarily identical to XPath syntax

### toString

    public String toString()

  Produce a representation of this type name for use in error messages.

  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of the type, in notation resembling but not necessarily identical to XPath syntax

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized

  Specified by:
    `getAtomizedItemType` in interface `ItemType`
  Returns:
    the item type of the atomic values that will be produced when an item of this type is atomized

### isAtomizable

    public boolean isAtomizable()

  Ask whether values of this type are atomizable

  Specified by:
    `isAtomizable` in interface `ItemType`
  Returns:
    true unless it is known that these items will be elements with element-only content, in which case return false

### relationship

    public int relationship(FunctionItemType other,
                            TypeHierarchy th)

  Determine the relationship of one function item type to another

  Specified by:
    `relationship` in interface `FunctionItemType`
  Returns:
    for example `TypeHierarchy.SUBSUMES`, `TypeHierarchy.SAME_TYPE`

### makeFunctionSequenceCoercer

    public Expression makeFunctionSequenceCoercer(Expression exp,
                                                  RoleLocator role,
                                                  TypeCheckerEnvironment visitor)
                                           throws XPathException

  Create an expression whose effect is to apply function coercion to coerce a function from this type to another type

  Specified by:
    `makeFunctionSequenceCoercer` in interface `FunctionItemType`
  Parameters:
    `exp` - the expression that delivers the supplied sequence of function items (the ones in need of coercion)
    `role` - information for use in diagnostics
    `visitor` - the expression visitor, supplies context information
  Returns:
    the coerced function, a function that calls the original function after checking the parameters
  Throws:
    `XPathException`

### visitNamedSchemaComponents

    public void visitNamedSchemaComponents(SchemaComponentVisitor visitor)
                                    throws XPathException

  Visit all the schema components used in this ItemType definition

  Specified by:
    `visitNamedSchemaComponents` in interface `ItemType`
  Parameters:
    `visitor` - the visitor class to be called when each component is visited
  Throws:
    `XPathException` - if an error occurs

### getResultType

    public SequenceType getResultType()

  Get the result type

  Specified by:
    `getResultType` in interface `FunctionItemType`
  Returns:
    the result type

### getDefaultPriority

    public double getDefaultPriority()

  Description copied from interface: `ItemType`
  Determine the default priority of this item type when used on its own as a Pattern

  Specified by:
    `getDefaultPriority` in interface `ItemType`
  Returns:
    the default priority

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.